#include <SFML/Graphics.hpp>
#include <memory>
#include <iostream>
#include <bitset>

auto bitwise = [](short bit, sf::Text& text, std::vector<sf::Sprite>& ons) {
  std::bitset<8> bitset(bit);
  std::cout << bitset << std::endl;
  text.setString(bitset.to_string());

  for (size_t i = 0; i < ons.size(); ++i) {
    if (bit & (1 << i)) {
      ons[7 - i].setColor(sf::Color::White);
    } else {
      ons[7 - i].setColor(sf::Color(255, 255, 255, 50));
    }
  }
};

int main() {
  auto window = std::make_unique<sf::RenderWindow>(
    sf::VideoMode(1280, 720), 
    "Bitwise::C++",
    sf::Style::Titlebar | sf::Style::Close
  );
  window->setPosition(sf::Vector2i(150, 100));
   
  sf::Font font;
  if (!font.loadFromFile("./resources/font.ttf")) {
    std::cerr << "Erro ao carregar a fonte!\n";
    return EXIT_FAILURE;
  }

  sf::Text text("00000000", font, 54);
  text.setPosition(494.f, 580.f);

  std::vector<sf::Vector2f> onpos = {
    {90.f, 60.f}, {226.f, 60.f}, {365.f, 60.f}, {502.f, 60.f},
    {639.f, 60.f}, {776.f, 60.f}, {914.f, 60.f}, {1050.f, 60.f}
  };

  sf::Texture texture, background;
  if (!texture.loadFromFile("./resources/on.png") || !background.loadFromFile("./resources/bg-bitwise.png")) {
    std::cerr << "Erro ao carregar as imagens!\n";
    return EXIT_FAILURE;
  }

  sf::Sprite bg(background);
  std::vector<sf::Sprite> ons;

  for (size_t i = 0; i < onpos.size(); ++i) {
    sf::Sprite temp_on(texture);
    temp_on.setPosition(onpos[i]);
    ons.push_back(temp_on);
  }

  short REG = {};
  short num = {};
  bitwise(REG, text, ons);

  while (window->isOpen()) {
    const auto event = std::make_unique<sf::Event>();
    while (window->pollEvent(*event)) {
      if (event->type == sf::Event::Closed) {
        window->close();
      }

      if (event->type == sf::Event::KeyPressed && event->key.code == sf::Keyboard::Space) {
        bitwise(REG, text, ons);
        num = (num >= 7) ? 0 : ++num;
      }
    }

    window->clear();
    window->draw(bg);

    for (const auto& var : ons) {
      window->draw(var);
    }

    window->draw(text);
    window->display();
  }

  return EXIT_SUCCESS;
}

